/*
 * File: iframeResizer.contentWindow.js
 * Desc: Include this file in any page being loaded into an iframe
 *       to force the iframe to resize to the content size.
 * Requires: iframeResizer.js on host page.
 * Doc: https://github.com/davidjbradshaw/iframe-resizer
 * Author: David J. Bradshaw - dave@bradshaw.net
 * @preserve
 */
!function(e){if("undefined"!=typeof window){var t=!0,n=10,o="",i=0,r="",a=null,u="",c=!1,d={resize:1,click:1},s=128,l=!0,f=1,m="bodyOffset",h=m,p=!0,v="",y={},g=32,w=null,b=!1,T=!1,E="[iFrameSizer]",O=E.length,S="",M={max:1,min:1,bodyScroll:1,documentElementScroll:1},N="child",I=!0,A=window.parent,C="*",z=0,x=!1,L=null,R=16,k=1,F="scroll",q=F,D=window,P=function(){re("onMessage function not defined")},W=function(){},H=function(){},j={height:function(){return re("Custom height calculation function not defined"),document.documentElement.offsetHeight},width:function(){return re("Custom width calculation function not defined"),document.body.scrollWidth}},B={},J=!1;try{var U=Object.create({},{passive:{get:function(){J=!0}}});window.addEventListener("test",te,U),window.removeEventListener("test",te,U)}catch(e){}var V,X,Y,K,Q,G,Z,$={bodyOffset:function(){return document.body.offsetHeight+ve("marginTop")+ve("marginBottom")},offset:function(){return $.bodyOffset()},bodyScroll:function(){return document.body.scrollHeight},custom:function(){return j.height()},documentElementOffset:function(){return document.documentElement.offsetHeight},documentElementScroll:function(){return document.documentElement.scrollHeight},max:function(){return Math.max.apply(null,ge($))},min:function(){return Math.min.apply(null,ge($))},grow:function(){return $.max()},lowestElement:function(){return Math.max($.bodyOffset()||$.documentElementOffset(),ye("bottom",be()))},taggedElement:function(){return we("bottom","data-iframe-height")}},_={bodyScroll:function(){return document.body.scrollWidth},bodyOffset:function(){return document.body.offsetWidth},custom:function(){return j.width()},documentElementScroll:function(){return document.documentElement.scrollWidth},documentElementOffset:function(){return document.documentElement.offsetWidth},scroll:function(){return Math.max(_.bodyScroll(),_.documentElementScroll())},max:function(){return Math.max.apply(null,ge(_))},min:function(){return Math.min.apply(null,ge(_))},rightMostElement:function(){return ye("right",be())},taggedElement:function(){return we("right","data-iframe-width")}},ee=(V=Te,Q=null,G=0,Z=function(){G=Date.now(),Q=null,K=V.apply(X,Y),Q||(X=Y=null)},function(){var e=Date.now();G||(G=e);var t=R-(e-G);return X=this,Y=arguments,t<=0||t>R?(Q&&(clearTimeout(Q),Q=null),G=e,K=V.apply(X,Y),Q||(X=Y=null)):Q||(Q=setTimeout(Z,t)),K});ne(window,"message",(function(t){var n={init:function(){v=t.data,A=t.source,ae(),l=!1,setTimeout((function(){p=!1}),s)},reset:function(){p?ie():(ie(),Se("resetPage"))},resize:function(){Ee("resizeParent","Parent window requested size check")},moveToAnchor:function(){y.findTarget(i())},inPageLink:function(){this.moveToAnchor()},pageInfo:function(){var e=i();ie(),H(JSON.parse(e)),ie()},message:function(){var e=i();ie(),P(JSON.parse(e)),ie()}};function o(){return t.data.split("]")[1].split(":")[0]}function i(){return t.data.slice(t.data.indexOf(":")+1)}function r(){return t.data.split(":")[2]in{true:1,false:1}}function a(){var i=o();i in n?n[i]():("undefined"==typeof module||!module.exports)&&"iFrameResize"in window||window.jQuery!==e&&"iFrameResize"in window.jQuery.prototype||r()||re(t.data)}E===(""+t.data).slice(0,O)&&(!1===l?a():r()?n.init():ie(o()))})),ne(window,"readystatechange",Ie),Ie()}function te(){}function ne(e,t,n,o){e.addEventListener(t,n,!!J&&(o||{}))}function oe(e){return e.charAt(0).toUpperCase()+e.slice(1)}function ie(e){b&&window.console}function re(e){window.console}function ae(){var n;!function(){function n(e){return"true"===e}var a=v.slice(O).split(":");S=a[0],i=e===a[1]?i:Number(a[1]),c=e===a[2]?c:n(a[2]),b=e===a[3]?b:n(a[3]),g=e===a[4]?g:Number(a[4]),t=e===a[6]?t:n(a[6]),r=a[7],h=e===a[8]?h:a[8],o=a[9],u=a[10],z=e===a[11]?z:Number(a[11]),y.enable=e!==a[12]&&n(a[12]),N=e===a[13]?N:a[13],q=e===a[14]?q:a[14],T=e===a[15]?T:n(a[15])}(),ie(window.location.href),function(){function e(){var e=window.iFrameResizer;ie(JSON.stringify(e)),Object.keys(e).forEach(ue,e),P="onMessage"in e?e.onMessage:P,W="onReady"in e?e.onReady:W,C="targetOrigin"in e?e.targetOrigin:C,h="heightCalculationMethod"in e?e.heightCalculationMethod:h,q="widthCalculationMethod"in e?e.widthCalculationMethod:q}function t(e,t){return"function"==typeof e&&(ie(),j[t]=e,e="custom"),e}"iFrameResizer"in window&&Object===window.iFrameResizer.constructor&&(e(),h=t(h,"height"),q=t(q,"width"));ie()}(),function(){e===r&&(r=i+"px");ce("margin",function(e,t){-1!==t.indexOf("-")&&(re(),t="");return t}(0,r))}(),ce("background",o),ce("padding",u),(n=document.createElement("div")).style.clear="both",n.style.display="block",n.style.height="0",document.body.appendChild(n),fe(),me(),document.documentElement.style.height="",document.body.style.height="",ie(),ie(),D.parentIFrame={autoResize:function(e){return!0===e&&!1===t?(t=!0,he()):!1===e&&!0===t&&(t=!1,se("remove"),null!==a&&a.disconnect(),clearInterval(w)),Ne(0,0,"autoResize",JSON.stringify(t)),t},close:function(){Ne(0,0,"close")},getId:function(){return S},getPageInfo:function(e){"function"==typeof e?(H=e,Ne(0,0,"pageInfo")):(H=function(){},Ne(0,0,"pageInfoStop"))},moveToAnchor:function(e){y.findTarget(e)},reset:function(){Me("parentIFrame.reset")},scrollTo:function(e,t){Ne(t,e,"scrollTo")},scrollToOffset:function(e,t){Ne(t,e,"scrollToOffset")},sendMessage:function(e,t){Ne(0,0,"message",JSON.stringify(e),t)},setHeightCalculationMethod:function(e){h=e,fe()},setWidthCalculationMethod:function(e){q=e,me()},setTargetOrigin:function(e){ie(),C=e},size:function(e,t){Ee("size","parentIFrame.size("+(e||"")+(t?","+t:"")+")",e,t)}},function(){if(!0!==T)return;function e(e){Ne(0,0,e.type,e.screenY+":"+e.screenX)}function t(t,n){ie(),ne(window.document,t,e)}t("mouseenter","Mouse Enter"),t("mouseleave","Mouse Leave")}(),he(),y=function(){function t(){return{x:window.pageXOffset===e?document.documentElement.scrollLeft:window.pageXOffset,y:window.pageYOffset===e?document.documentElement.scrollTop:window.pageYOffset}}function n(e){var n=e.getBoundingClientRect(),o=t();return{x:parseInt(n.left,10)+parseInt(o.x,10),y:parseInt(n.top,10)+parseInt(o.y,10)}}function o(t){function o(e){var t=n(e);ie((t.x,t.y)),Ne(t.y,t.x,"scrollToOffset")}var i=t.split("#")[1]||t,r=decodeURIComponent(i),a=document.getElementById(r)||document.getElementsByName(r)[0];e===a?(ie(),Ne(0,0,"inPageLink","#"+i)):o(a)}function i(){var e=window.location.hash,t=window.location.href;""!==e&&"#"!==e&&o(t)}function r(){function e(e){function t(e){e.preventDefault(),o(this.getAttribute("href"))}"#"!==e.getAttribute("href")&&ne(e,"click",t)}Array.prototype.forEach.call(document.querySelectorAll('a[href^="#"]'),e)}function a(){ne(window,"hashchange",i)}function u(){setTimeout(i,s)}function c(){Array.prototype.forEach&&document.querySelectorAll?(ie(),r(),a(),u()):re()}y.enable?c():ie();return{findTarget:o}}(),Ee("init","Init message from host page"),W()}function ue(e){var t=e.split("Callback");if(2===t.length){var n="on"+t[0].charAt(0).toUpperCase()+t[0].slice(1);this[n]=this[e],delete this[e],re()}}function ce(t,n){e!==n&&""!==n&&"null"!==n&&(document.body.style[t]=n,ie())}function de(e){var t={add:function(t){function n(){Ee(e.eventName,e.eventType)}B[t]=n,ne(window,t,n,{passive:!0})},remove:function(e){var t,n,o,i=B[e];delete B[e],t=window,n=e,o=i,t.removeEventListener(n,o,!1)}};e.eventNames&&Array.prototype.map?(e.eventName=e.eventNames[0],e.eventNames.map(t[e.method])):t[e.method](e.eventName),ie((oe(e.method),e.eventType))}function se(e){de({method:e,eventType:"Animation Start",eventNames:["animationstart","webkitAnimationStart"]}),de({method:e,eventType:"Animation Iteration",eventNames:["animationiteration","webkitAnimationIteration"]}),de({method:e,eventType:"Animation End",eventNames:["animationend","webkitAnimationEnd"]}),de({method:e,eventType:"Input",eventName:"input"}),de({method:e,eventType:"Mouse Up",eventName:"mouseup"}),de({method:e,eventType:"Mouse Down",eventName:"mousedown"}),de({method:e,eventType:"Orientation Change",eventName:"orientationchange"}),de({method:e,eventType:"Print",eventNames:["afterprint","beforeprint"]}),de({method:e,eventType:"Ready State Change",eventName:"readystatechange"}),de({method:e,eventType:"Touch Start",eventName:"touchstart"}),de({method:e,eventType:"Touch End",eventName:"touchend"}),de({method:e,eventType:"Touch Cancel",eventName:"touchcancel"}),de({method:e,eventType:"Transition Start",eventNames:["transitionstart","webkitTransitionStart","MSTransitionStart","oTransitionStart","otransitionstart"]}),de({method:e,eventType:"Transition Iteration",eventNames:["transitioniteration","webkitTransitionIteration","MSTransitionIteration","oTransitionIteration","otransitioniteration"]}),de({method:e,eventType:"Transition End",eventNames:["transitionend","webkitTransitionEnd","MSTransitionEnd","oTransitionEnd","otransitionend"]}),"child"===N&&de({method:e,eventType:"IFrame Resized",eventName:"resize"})}function le(e,t,n,o){return t!==e&&(e in n||(re(),e=t),ie()),e}function fe(){h=le(h,m,$)}function me(){q=le(q,F,_)}function he(){var e;!0===t?(se("add"),e=0>g,window.MutationObserver||window.WebKitMutationObserver?e?pe():a=function(){function e(e){function t(e){!1===e.complete&&(ie(e.src),e.addEventListener("load",i,!1),e.addEventListener("error",r,!1),c.push(e))}"attributes"===e.type&&"src"===e.attributeName?t(e.target):"childList"===e.type&&Array.prototype.forEach.call(e.target.querySelectorAll("img"),t)}function t(e){c.splice(c.indexOf(e),1)}function n(e){ie(e.src),e.removeEventListener("load",i,!1),e.removeEventListener("error",r,!1),t(e)}function o(e,t,o){n(e.target),Ee(t,o+": "+e.target.src)}function i(e){o(e,"imageLoad","Image loaded")}function r(e){o(e,"imageLoadFailed","Image load failed")}function a(t){Ee("mutationObserver","mutationObserver: "+t[0].target+" "+t[0].type),t.forEach(e)}function u(){var e=document.querySelector("body"),t={attributes:!0,attributeOldValue:!1,characterData:!0,characterDataOldValue:!1,childList:!0,subtree:!0};return s=new d(a),ie(),s.observe(e,t),s}var c=[],d=window.MutationObserver||window.WebKitMutationObserver,s=u();return{disconnect:function(){"disconnect"in s&&(ie(),s.disconnect(),c.forEach(n))}}}():(ie(),pe())):ie()}function pe(){0!==g&&(ie(),w=setInterval((function(){Ee("interval","setInterval: "+g)}),Math.abs(g)))}function ve(e,t){var o=0;return t=t||document.body,o=null===(o=document.defaultView.getComputedStyle(t,null))?0:o[e],parseInt(o,n)}function ye(e,t){for(var n=t.length,o=0,i=0,r=oe(e),a=Date.now(),u=0;u<n;u++)(o=t[u].getBoundingClientRect()[e]+ve("margin"+r,t[u]))>i&&(i=o);return a=Date.now()-a,ie(),ie(),function(e){e>R/2&&(R=2*e,ie())}(a),i}function ge(e){return[e.bodyOffset(),e.bodyScroll(),e.documentElementOffset(),e.documentElementScroll()]}function we(e,t){var n=document.querySelectorAll("["+t+"]");return 0===n.length&&(re(),document.querySelectorAll("body *")),ye(e,n)}function be(){return document.querySelectorAll("body *")}function Te(t,n,o,i){var r,a;!function(){function t(e,t){return!(Math.abs(e-t)<=z)}return r=e===o?$[h]():o,a=e===i?_[q]():i,t(f,r)||c&&t(k,a)}()&&"init"!==t?!(t in{init:1,interval:1,size:1})&&(h in M||c&&q in M)?Me(n):t in{interval:1}||ie():(Oe(),Ne(f=r,k=a,t))}function Ee(e,t,n,o){x&&e in d?ie():(e in{reset:1,resetPage:1,init:1}||ie(),"init"===e?Te(e,t,n,o):ee(e,t,n,o))}function Oe(){x||(x=!0,ie()),clearTimeout(L),L=setTimeout((function(){x=!1,ie(),ie()}),s)}function Se(e){f=$[h](),k=_[q](),Ne(f,k,e)}function Me(e){var t=h;h=m,ie(),Oe(),Se("reset"),h=t}function Ne(t,n,o,i,r){var a;!0===I&&(e===r?r=C:ie(),a=S+":"+t+":"+n+":"+o+(e===i?"":":"+i),ie(),A.postMessage(E+a,r))}function Ie(){"loading"!==document.readyState&&window.parent.postMessage("[iFrameResizerChild]Ready","*")}}();